;**********************************************************
;* TITLE TSTZ104.ASM             BY TAC INC.  
;* A/D,D/ÃTu[`gpTvvO *
;* T104-DIO72	:	000H
;* T104-ADA	:  	020H
;* T104-AD16S	:	040H
;*  
;*  
;* @ASIO,PIO,8255̃eXgACTC̃^C}[荞
;* PIO,8255̃f[^Vtg
;* NMI荞݂T104-ADA,T104-AD16SA/D,D/ÃeXg					  
;**********************************************************
.Z80
;
;************** |[g̊ T104-Z80CPU@*****************
SIOAD:	EQU	018H		;CN4@SIO
SIOAC:	EQU	019H		
SIOBD:	EQU	01AH		;CN3  SIO
SIOBC:	EQU	01BH
;
PIOAD:	EQU	01CH		;CN2
PIOAC:	EQU	01DH		;CN2
PIOBD:	EQU	01EH		;CN2
PIOBC:	EQU	01FH		;CN2
;
WDT:	EQU	0F0H
;
CTC0:	EQU	010H		;CN5
;
RIC:	EQU	038H		;vhbAhX
;
;************** |[g̊ T104-DIO72 @*****************
DIOB:	EQU	00H
;
PA1:	EQU	DIOB + 00H	;CN3@WQTT
PB1:	EQU	DIOB + 01H
PC1:	EQU	DIOB + 02H
PW1:	EQU	DIOB + 03H
;
PA2:	EQU	DIOB + 04H	;CN4@WQTT
PB2:	EQU	DIOB + 05H
PC2:	EQU	DIOB + 06H
PW2:	EQU	DIOB + 07H
;
PA3:	EQU	DIOB + 08H	;CN5@WQTT
PB3:	EQU	DIOB + 09H
PC3:	EQU	DIOB + 0AH
PW3:	EQU	DIOB + 0BH
;
;************** |[g̊ T104-ADA@*****************
ADAB:	EQU	020H
;
DAL1:	EQU	ADAB + 00H	;D/ARo[^PʂWrbg
DAU1:	EQU	ADAB + 01H	;D/ARo[^PʂSrbg
;
DAL2:	EQU	ADAB + 02H	;D/ARo[^QʂWrbg
DAU2:	EQU	ADAB + 03H	;D/ARo[^QʂSrbg
;
DAL3:	EQU	ADAB + 04H	;D/ARo[^RʂWrbg
DAU3:	EQU	ADAB + 05H	;D/ARo[^RʂSrbg
;
DAL4:	EQU	ADAB + 06H	;D/ARo[^SʂWrbg
DAU4:	EQU	ADAB + 07H	;D/ARo[^SʂSrbg
;
LDAC:	EQU	ADAB + 00H	;D/A12BIT LATCH
;
ADL:	EQU	ADAB + 08H	;A/DRo[^8rbg
ADU:	EQU	ADAB + 09H	;A/DRo[^4rbg
ADSTS:	EQU	ADAB + 0AH	;A/DRo[^ STS.BIT 7L̎ϊ
;
;************** |[g̊ T104-AD16S@*****************
AD16B:	EQU	040H
;
AD2L:	EQU	AD16B + 01H	;A/DRo[^4rbg
AD2U:	EQU	AD16B + 00H	;A/DRo[^8rbg
AD2STS:	EQU	AD16B + 02H	;A/DRo[^ STS.BIT 7H̎ϊ
AD2CH:	EQU	AD16B + 02H	;A/DRo[^ ch ZNg
;
;
	ORG	0000H
	JP	0100H
	;
;***********************************************
;*  @@@
;***********************************************
	ORG	08000H

;***********************************************
;*  @@@m}XJu荞
;***********************************************
	ORG	066H
	DI
	JP	ADDA	
;**********************************************
;*	   荞݃xN^                     *
;**********************************************
	ORG	10H	;ʂSrbgOOOOɂ
VECTOR:	
	DW	INT
	;
;**********************************************
;*	                                *
;**********************************************
	ORG	0100H
INIT:
	LD	SP,0FFFFH
	;
	;
	LD	A,080H		;DIO72̂WQTTׂĂntsɐݒ
	OUT 	(PW1),A
	OUT 	(PW2),A
	OUT 	(PW3),A
	;			;CTC INIT.
	LD	HL,VECTOR
	LD	A,H
	LD	I,A
	IM	2
	LD	A,0C7H		;COUNTER MODE INT 
				;DOWN EDGE
	OUT	(CTC0),A	;LOAD CONTROL W.
	LD	A,0200		;TIME CONSTANT SET FOR 3Hz
	OUT	(CTC0),A	;
	LD	A,L		;LOWER VECTOR SET
	OUT	(CTC0),A	;
	DI			;C^[vg@fBXG[u
	;
	LD	A,047H		;COUNTER MODE NO INT
	OUT	(CTC0+1),A
	LD	A,0		;153.6KHz / 256 = 600Hz
	OUT	(CTC0+1),A
	;
	LD	A,07H		;{[[gݒ 9.8304MHz 9600BPS 16
	OUT	(CTC0+2),A
	LD	A,04		;(9.8304MHz / 16) / 4 = 153.6KHz
	OUT	(CTC0+2),A
	;
	LD	A,07H		;{[[gݒ 9.8304MHz 9600BPS 16
	OUT	(CTC0+3),A
	LD	A,04		;(9.8304MHz / 16) / 4 = 153.6KHz
	OUT	(CTC0+3),A
	;
	LD	A,018H		;SIO A INIT.
	OUT	(SIOAC),A
	LD	A,01H
	OUT	(SIOAC),A
	LD	A,0H
	OUT	(SIOAC),A
	LD	A,03H
	OUT	(SIOAC),A
	LD	A,0C1H
	OUT	(SIOAC),A
	LD	A,04H
	OUT	(SIOAC),A
	LD	A,044H
	OUT	(SIOAC),A
	LD	A,05H
	OUT	(SIOAC),A
	LD	A,0EAH
	OUT	(SIOAC),A
	;
	LD	A,018H		;SIO B INIT.
	OUT	(SIOBC),A
	LD	A,01H
	OUT	(SIOBC),A
	LD	A,0H
	OUT	(SIOBC),A
	LD	A,03H
	OUT	(SIOBC),A
	LD	A,0C1H
	OUT	(SIOBC),A
	LD	A,04H
	OUT	(SIOBC),A
	LD	A,044H
	OUT	(SIOBC),A
	LD	A,05H
	OUT	(SIOBC),A
	LD	A,0EAH
	OUT	(SIOBC),A
	;
	;
	LD	A,0FFH		;Z80 PIO INIT.
	OUT	(PIOAC),A
	LD	A,00
	OUT	(PIOAC),A
	LD	A,07
	OUT	(PIOAC),A
	;
	LD	A,0FFH		;Z80 PIO INIT.
	OUT	(PIOBC),A
	LD	A,00
	OUT	(PIOBC),A
	LD	A,07
	OUT	(PIOBC),A
	;
	;
	LD	BC,RIC+0E00H	;RC15 INIT.
	LD	A,0
	OUT	(C),A
	;
	LD	BC,RIC+0D00H	;TEST RESISTA
	LD	A,09H
	OUT	(C),A
	;
	LD	BC,RIC+0A00H	;24 TIME
	LD	A,01H
	OUT	(C),A
	;
	LD	BC,RIC+0D00H	;MODE
	LD	A,08H
	OUT	(C),A
	;
;*******************************************************************
;  CAt@Cq`lArhnAbsbAWQTT̃`FbN 
;*******************************************************************
MAIN:
;
				;C̃`FbN
	XOR	A
	LD	HL,08000H	;RAM TEST 
	LD	B,00
RAMTEST:
	LD	A,B
	LD	(HL),A
	LD	A,(HL)
	CP	B
	JP	NZ,ERR
	INC	B
	INC	HL
	LD	A,H
	CP	0FFH
	JP	NZ,RAMTEST
	;
	;
				;SIOTEST
	IN	A,(SIOAD)	;DUMMY
	IN	A,(SIOBD)	;DUMMY
	;
	LD	A,0
	LD	B,0
SIOTEST:
	LD	A,B
	CALL	CKTXA		;CK TX A
	CALL	CTSCKA		;CTS,DCD CK
	OUT	(SIOAD),A	;SIO OUT
	CALL	CKRXB		;CK RX B
	CALL	CTSCKB		;CTS,DCD CK
	IN	A,(SIOBD)	;SIO IN
	OUT	(PIOAD),A	;MONITOER
	CP	B
	JP	NZ,ERR
	INC	B
	LD	A,B
	CP	00
	JR	NZ,SIOTEST
	;
	LD	A,0
	LD	B,0
SIOTEST2:
	LD	A,B
	CALL	CKTXB		;CK TX B
	CALL	CTSCKB		;CTS,DCD CK
	OUT	(SIOBD),A	;SIO OUT
	CALL	CKRXA		;CK RX A
	CALL	CTSCKA		;CTS,DCD CK
	IN	A,(SIOAD)	;SIO IN
	OUT	(PIOBD),A	;MONITER
	CP	B
	JP	NZ,ERR
	INC	B
	LD	A,B
	CP	00
	JR	NZ,SIOTEST2
	;
	;
	LD	B,0		;8255 CHECK
CKPA:
	LD	A,B
	OUT	(PA1),A
	OUT	(PA2),A
	OUT	(PA3),A
	
	IN	A,(PA1)
	CP	B
	JP	NZ,ERR
	IN	A,(PA2)
	CP	B
	JP	NZ,ERR
	IN	A,(PA3)
	CP	B
	JP	NZ,ERR
	DEC	B
	JP	NZ,CKPA
	;
	LD	B,0		;8255 CHECK
CKPB:
	LD	A,B
	OUT	(PB1),A
	OUT	(PB2),A
	OUT	(PB3),A
	
	IN	A,(PB1)
	CP	B
	JP	NZ,ERR
	IN	A,(PB2)
	CP	B
	JP	NZ,ERR
	IN	A,(PB3)
	CP	B
	JP	NZ,ERR
	DEC	B
	JP	NZ,CKPB
	;
	LD	B,0		;8255 CHECK
CKPC:
	LD	A,B
	OUT	(PC1),A
	OUT	(PC2),A
	OUT	(PC3),A
	
	IN	A,(PC1)
	CP	B
	JP	NZ,ERR
	IN	A,(PC2)
	CP	B
	JP	NZ,ERR
	IN	A,(PC3)
	CP	B
	JP	NZ,ERR
	DEC	B
	JP	NZ,CKPC
	;
CKPIOA:
	LD	A,B
	OUT	(PIOAD),A
	
	IN	A,(PIOAD)
	CP	B
	JP	NZ,ERR
	DEC	B
	JP	NZ,CKPIOA
	;
CKPIOB:
	LD	A,B
	OUT	(PIOBD),A
	
	IN	A,(PIOBD)
	CP	B
	JP	NZ,ERR
	DEC	B
	JP	NZ,CKPIOB
	;
	LD	A,1		;8255 CHECK
	OUT	(PA1),A
	OUT	(PA2),A
	OUT	(PA3),A
	;
	LD	A,2
	OUT	(PB1),A
	OUT	(PB2),A
	OUT	(PB3),A
	;
	LD	A,4
	OUT	(PC1),A
	OUT	(PC2),A
	OUT	(PC3),A
	;
	LD	A,1
	OUT	(PIOAD),A
	LD	A,2
	OUT	(PIOBD),A
	;
	;
	;
	EI
HHALT:
	HALT
	JP	HHALT
	;
ERR:
	LD	A,0FFH
	OUT	(PA1),A
	OUT	(PA2),A
	;
	OUT	(PB1),A
	OUT	(PB2),A
	;
	OUT	(PC1),A
	OUT	(PC2),A
	;
	JP	ERR

;*********************************
;* 荞
;*********************************
INT:
	;
	IN	A,(PA1)
	RLCA
	OUT	(PA1),A
	IN	A,(PA2)
	RLCA
	OUT	(PA2),A
	IN	A,(PA3)
	RLCA
	OUT	(PA3),A
	;
	IN	A,(PB1)
	RLCA
	OUT	(PB1),A
	IN	A,(PB2)
	RLCA
	OUT	(PB2),A
	IN	A,(PB3)
	RLCA
	OUT	(PB3),A
	;
	IN	A,(PC1)
	RLCA
	OUT	(PC1),A
	IN	A,(PC2)
	RLCA
	OUT	(PC2),A
	IN	A,(PC3)
	RLCA
	OUT	(PC3),A
	;
	IN	A,(PIOAD)
	RLCA
	OUT	(PIOAD),A
	IN	A,(PIOBD)
	RLCA
	OUT	(PIOBD),A
	;
	;
	EI
	RETI
	;
	
ADDA:
	LD	A,0FH		;T104-AD16S A/Dϊ
	CALL	AD16CT		;DE <--- DATA
	;
	LD	C,PIOAD		;
	OUT	(C),E		;T104-Z80CPU PIO AɉʂWrbg̃f[^
	LD	C,PIOBD
	OUT	(C),D		;T104-Z80CPU PIO BɏʂSrbg̃f[^
	;
	LD	A,00		;T104-ADA S1IAA/Dϊ
	CALL	ADCTX		;DE <--- DATA
	;
	LD	C,PA1		;
	OUT	(C),E		;|[g`ɉʂWrbg̃f[^
	LD	C,PB1
	OUT	(C),D		;|[gaɏʂSrbg̃f[^
	;
	LD	C,PA2		;
	OUT	(C),E		;|[g`ɉʂWrbg̃f[^
	LD	C,PB2
	OUT	(C),D		;|[gaɏʂSrbg̃f[^
	;
	LD	C,PA3		;
	OUT	(C),E		;|[g`ɉʂWrbg̃f[^
	LD	C,PB3
	OUT	(C),D		;|[gaɏʂSrbg̃f[^
	;
	LD	A,00		;c^`ϊ
	CALL	DACX		;
	;
	LD	A,01		;c^`ϊ
	CALL	DACX		;
	;
	LD	A,02		;c^`ϊ
	CALL	DACX		;
	;
	LD	A,03		;c^`ϊ
	CALL	DACX		;
	;
	;
	;
	;
				;CTS,DCD CHECK
	LD	A,010H		;CTS,DCD RESET
	OUT	(SIOAC),A
	;
	IN	A,(SIOAC)
	OUT	(PIOAD),A
	BIT	5,A
	JR	Z,RON
	CALL	RTSONA
NEXT1:
	LD	A,010H		;CTS,DCD RESET
	OUT	(SIOBC),A
	;
	IN	A,(SIOBC)
	OUT	(PIOBD),A
	BIT	5,A
	JR	Z,RON2
	CALL	RTSONB
NEXT2:
	JP	ADDA		;[v
	;
	;
	;
RON:
	CALL	RTSOFA
	JR	NEXT1
RON2:
	CALL	RTSOFB
	JR	NEXT2
	;
	;
;*********************************************************************
;*    TITLE  ADCTX T104-ADAA/D                                     *
;*  `^cRo[^@f[^̓Tu[`iO`Túj       @*
;*@@`WX^Ƀ}`vNT̓̓`li0`7j       *
;*@R[ƂcdWX^ɂ`^cϊlԂB               *
;*    A  <--- CH.       DE <--- 12 BIT DATA                          *
;*********************************************************************
ADCTX:
	PUSH	AF
	OUT	(ADL),A		;`cϊJn
LOOPAD:
	IN	A,(ADSTS)	;ϊIH
	BIT	7,A
	JR	Z,LOOPAD
	;
	IN	A,(ADL)		;READ 8 LSB
	LD	E,A
	IN	A,(ADU)		;READ 4 MSB
	LD	D,A
	;
	POP	AF
	RET
;*********************************************************************
;*    TITLE  DACX T104-ADAD/A                                      *
;*  c^`Ro[^@f[^o̓Tu[`                       @*
;*@@`WX^ɂc^``liO`RjAcdWX^Ɂ@@@@ *
;*@PQrbg̃f[^ăR[B`lO`R         *
;*    A  <--- CH.       DE <--- 12 BIT DATA                          *
;*********************************************************************
DACX:
	PUSH	AF
	;
	CP	1
	JR	C,DAOUT_0
	JR	Z,DAOUT_1
	CP	3
	JR	C,DAOUT_2
	JR	Z,DAOUT_3
	;
	JR	DARET
	;
DAOUT_0:
	LD	A,E
	OUT	(DAL1),A
	LD	A,D
	OUT	(DAU1),A
	JR	DARET
	;
DAOUT_1:
	LD	A,E
	OUT	(DAL2),A
	LD	A,D
	OUT	(DAU2),A
	JR	DARET
	;
DAOUT_2:
	LD	A,E
	OUT	(DAL3),A
	LD	A,D
	OUT	(DAU3),A
	JR	DARET
	;
DAOUT_3:
	LD	A,E
	OUT	(DAL4),A
	LD	A,D
	OUT	(DAU4),A
	JR	DARET
	;
DARET:
	IN 	A,(LDAC)	;PQrbgb`
	;
	POP	AF
	RET
	;
;*********************************************************************
;*    TITLE  AD16CT T104-AD16SA/D                                  *
;*  `^cRo[^@f[^̓Tu[`                       @*
;*@@`WX^Ƀ}`vNT̓̓`liO`PTj *
;*@R[ƂcdWX^ɂ`^cϊlԂB               *
;*    A  <--- CH.       DE <--- 12 BIT DATA                          *
;*********************************************************************
AD16CT:
	PUSH	AF
	OUT	(AD2CH),A	;}`vNT@ZNg 
	OUT	(AD2U),A	;`cϊJn
LOOPAD16:
	IN	A,(AD2STS)	;ϊIH
	BIT	7,A
	JR	NZ,LOOPAD16
	;
	IN	A,(AD2U)	;ʂWrbg[h
	LD	D,A
	IN	A,(AD2L)	;ʂSrbg[h
	AND	0F0H		;ʂSrbg}XN
	LD	E,A
	RR	D		;SrbgEփVtg
	RR	E
	RR	D
	RR	E
	RR	D
	RR	E
	RR	D
	RR	E
	;
	POP	AF
	RET
;****************************************
;* rhn`@Mobt@`FbN
;****************************************
CKTXA:
	PUSH	AF
LOTA:
	IN	A,(SIOAC)
	BIT	2,A
	JR	Z,LOTA
	POP	AF
	RET
;****************************************
;* rhna@Mobt@`FbN
;****************************************
CKTXB:
	PUSH	AF
LOTB:
	IN	A,(SIOBC)
	BIT	2,A
	JR	Z,LOTB
	POP	AF
	RET
;****************************************
;* rhn`@Mobt@`FbN
;****************************************
CKRXA:
	PUSH	AF
LORA:
	IN	A,(SIOAC)
	BIT	0,A
	JR	Z,LORA
	POP	AF
	RET
;****************************************
;* rhna@Mobt@`FbN
;****************************************
CKRXB:
	PUSH	AF
LORB:
	IN	A,(SIOBC)
	BIT	0,A
	JR	Z,LORB
	POP	AF
	RET
;*******************************************
;* rhn`̂qsrnm
;*******************************************
RTSONA:
	PUSH	AF
	LD	A,05H		;POINTS WR5
	OUT 	(SIOAC),A
	LD	A,0EAH		;RTS ON,DTR ON,8BIT
	OUT	(SIOAC),A
	
	POP	AF
	RET
;*******************************************
;* rhnâqsrnm
;*******************************************
RTSONB:
	PUSH	AF
	LD	A,05H		;POINTS WR5
	OUT 	(SIOBC),A
	LD	A,0EAH		;RTS ON,DTR ON,8BIT
	OUT	(SIOBC),A
	POP	AF
	RET
;*******************************************
;* rhn`̂qsrnee
;*******************************************
RTSOFA:
	PUSH	AF
	LD	A,05H		;POINTS WR5
	OUT 	(SIOAC),A
	LD	A,0E8H		;RTS OFF,DTR ON,8BIT
	OUT	(SIOAC),A
	POP	AF
	RET
;*******************************************
;* rhnâqsrnee
;*******************************************
RTSOFB:
	PUSH	AF
	LD	A,05H		;POINTS WR5
	OUT 	(SIOBC),A
	LD	A,0E8H		;RTS OFF,DTR ON,8BIT
	OUT	(SIOBC),A
	POP	AF
	RET
	;
;*******************************************
;* rhn`̂bsr̃`FbN
;* bsrnmɂȂ܂Ń[v
;*******************************************
CKCTSA:
	PUSH	AF
ZCKCA:
	IN	A,(SIOAC)
	BIT	5,A
	JR	Z,ZCKCA
	POP	AF
	RET
;*******************************************
;* rhnâbsr̃`FbN
;* bsrnmɂȂ܂Ń[v
;*******************************************
CKCTSB:
	PUSH	AF
ZCKCB:
	IN	A,(SIOAC)
	BIT	5,A
	JR	Z,ZCKCB
	POP	AF
	RET
	;
	;
;***************************************************
;* DCD,CTS CHECK SIOA
;****************************************************
CTSCKA:
	PUSH	AF
				;CTS,DCD CHECK
	LD	A,010H		;CTS,DCD RESET
	OUT	(SIOAC),A
	;
	IN	A,(SIOAC)
	AND	028H
	CP	028H
	JP	NZ,ERR2
	POP	AF
	RET
;***************************************************
;* DCD,CTS CHECK SIOB
;****************************************************
CTSCKB:
	PUSH	AF
				;CTS,DCD CHECK
	LD	A,010H		;CTS,DCD RESET
	OUT	(SIOBC),A
	;
	IN	A,(SIOBC)
	AND	028H
	CP	028H
	JP	NZ,ERR2
	POP	AF
	RET
	

ERR2:
				;CTS,DCD CHECK
	LD	A,010H		;CTS,DCD RESET
	OUT	(SIOAC),A
	;
	IN	A,(SIOAC)
	OUT	(PIOAD),A
	BIT	5,A
	JR	Z,RRON
	CALL	RTSONA
RNEXT1:
	LD	A,010H		;CTS,DCD RESET
	OUT	(SIOBC),A
	;
	IN	A,(SIOBC)
	OUT	(PIOBD),A
	BIT	5,A
	JR	Z,RRON2
	CALL	RTSONB
RNEXT2:


	
	
	
	
	JP	ERR2		;[v
RRON:
	CALL	RTSOFA
	JR	RNEXT1
RRON2:
	CALL	RTSOFB
	JR	RNEXT2

	;
	;
	END
